﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ParticleScript : MonoBehaviour {

	Vector3 posOld;

	Vector3 posFissato;

	public bool fissato = false;
	public float massa = 1.0f;
	public float drag = 0.2f;  // perdo il 20% di velocita AL SECONDO
	public static float ATTRITO_SUOLO = 20.0f;

	[HideInInspector]
	public Vector3 forze; // cumulazione delle forze

	void Start () {
		posFissato = posOld = transform.position;
		forze.Set (0, 0, 0);
	}

	Vector3 attritoAlSuolo ( Vector3 vel ){
		
		if (transform.position.y > 0.01f) return Vector3.zero;
			
		Vector3 f = -vel * ATTRITO_SUOLO;

		f.y = 0; // 
		return f;
	}

	void verletStep(){

		/* rename per leggibilita' */
		float dt = Time.deltaTime;
		Vector3 posNow = transform.position;

		forze += attritoAlSuolo (  (posNow - posOld)/dt );

		Vector3 acc = Vector3.down * 9.8f + forze / massa;

		forze.Set (0, 0, 0);

		Vector3 posNext = posNow * (2-drag*dt) - (1-drag*dt)*posOld + acc * dt * dt;
		enforceConstraints (ref posNext);

		posOld = posNow;
		transform.position = posNext;
	}

	void enforceConstraints( ref Vector3 posNext ){
		if (fissato) {
			posNext = posFissato;
		}
		if (posNext.y < 0) posNext.y = 0;
	}

	void FixedUpdate () {
		verletStep ();
	}


}
